var animate = false;

//
//Funkcja odpowiedzialna za wyliczenie wieku i ryzyka choroby
//
var _BadanieWiekuSerca = {
	wiek : 0,
	ryzyko : 0,
	inputs : {},
	PointsAge : {
		'm' : {
			'wiek' : [
				[34 , 0],
				[39 , 2],
				[44 , 5],
				[49 , 6],
				[54 , 8],
				[59 , 10],
				[64 , 11],
				[69 , 12],
				[74 , 14],
				[75 , 15]
			],
			'cholesterol' : [
				[159 , 0],
				[199 , 1],
				[239 , 2],
				[279 , 3],
				[280 , 4]
			],
			'hdl' : [
				[34 , 2],
				[44 , 1],
				[49 , 0],
				[59 , -1],
				[60 , -2]
			],
			'cisnienie' : [ //nie przyjuje lekow
				[119 , -2],
				[129 , 0],
				[139 , 1],
				[149 , 2],
				[159 , 2],
				[160 , 3]
			],
			'cisnienieLeki' : [ //przyjmuje leki
				[119 , 0],
				[129 , 2],
				[139 , 3],
				[149 , 4],
				[159 , 4],
				[160 , 5]
			],			
			'papierosy' : {
				1 : 4,
				0 : 0
			},
			'cukrzyca' : {
				1 : 3,
				0 : 0
			},
			'wiekSerca' : [
				[-1, '<span style="font-weight:100"><</span>30'],
				[0 , 30],
				[1 , 32],
				[2 , 34],
				[3 , 36],
				[4 , 38],
				[5 , 40],
				[6 , 42],
				[7 , 45],
				[8 , 48],
				[9 , 51],
				[10 , 54],
				[11 , 57],
				[12 , 60],
				[13 , 64],
				[14 , 68],
				[15 , 72],
				[16 , 76],
				[17 , '<span style="font-weight:100">></span>80']
			]
		},
		'f' : {
			'wiek' : [
				[34 , 0],
				[39 , 2],
				[44 , 4],
				[49 , 5],
				[54 , 7],
				[59 , 8],
				[64 , 9],
				[69 , 10],
				[74 , 11],
				[75 , 12]
			],
			'cholesterol' : [
				[159 , 0],
				[199 , 1],
				[239 , 3],
				[279 , 4],
				[280 , 5]
			],
			'hdl' : [
				[34 , 2],
				[44 , 1],
				[49 , 0],
				[59 , -1],
				[60 , -2]
			],
			'cisnienie' : [ //nie przyjuje lekow
				[119 , -3],
				[129 , 0],
				[139 , 1],
				[149 , 2],
				[159 , 4],
				[160 , 5]
			],
			'cisnienieLeki' : [ //przyjmuje leki
				[119 , -1],
				[129 , 2],
				[139 , 3],
				[149 , 5],
				[159 , 6],
				[160 , 7]
			],			
			'papierosy' : {
				1 : 3,
				0 : 0
			},
			'cukrzyca' : {
				1 : 4,
				0 : 0
			},
			'wiekSerca' : [
				[-1, '<span style="font-weight:100"><</span>30'],
				[0 , '<span style="font-weight:100"><</span>30'],
				[1 , 31],
				[2 , 34],
				[3 , 36],
				[4 , 39],
				[5 , 42],
				[6 , 45],
				[7 , 48],
				[8 , 51],
				[9 , 55],
				[10 , 59],
				[11 , 64],
				[12 , 68],
				[13 , 73],
				[14 , 79],
				[15 , '<span style="font-weight:100">></span>80'],
				[16 , '<span style="font-weight:100">></span>80'],
				[17 , '<span style="font-weight:100">></span>80']
			]
		}
	},
	RiskPercent : {
		'index' : { 
			'wiek' : [ 
				[45 , 0],
				[52 , 1],
				[57 , 2],
				[62 , 3],
				[67 , 4],
				[68 , 5]
			],
			'cisnienie' : [ 
				[130 , 0],
				[150 , 1],
				[170 , 2],
				[171 , 3]
			],
			'cholesterol' : [ 
				[170 , 0],
				[210 , 1],
				[250 , 2],
				[290 , 3],
				[291 , 4]
			]
		},
		'procent' : {//[procent][plec][papierosy][wiek] \/
			'm' : [ //plec
				[ //papierosy - nie
					[ //wiek 0-45
						//cisnieine 130
						[1,1,1,1,1], //cholesterol
						//cisnieine 131-150
						[1,1,1,2,2],
						//cisnieine 151-170
						[1,2,2,2,3],
						//cisnieine 171
						[2,2,3,3,4]
					],
					[ //wiek 46-52
						 //cisnieine 130
						[2,2,2,3,3], //cholesterol
						 //cisnieine 131-150
						[2,3,3,4,5],
						 //cisnieine 151-170
						[3,4,5,6,7],
						 //cisnieine 171
						[5,6,7,8,9]
					],
					[ //wiek 53-57
						 //cisnieine 130
						[2,3,3,4,5], //cholesterol
						 //cisnieine 131-150
						[3,4,5,6,7],
						 //cisnieine 151-170
						[5,6,7,8,10],
						 //cisnieine 171
						[7,8,10,12,14]
					],
					[ //wiek 58-62
						 //cisnieine 130
						[4,4,5,6,8], //cholesterol
						 //cisnieine 131-150
						[5,6,8,9,11],
						 //cisnieine 151-170
						[8,9,11,13,15],
						 //cisnieine 171
						[11,13,15,18,21]
					],
					[ //wiek 63-67
						 //cisnieine 130
						[6,7,9,10,12], //cholesterol
						 //cisnieine 131-150
						[9,10,12,14,17],
						 //cisnieine 151-170
						[12,14,17,20,24],
						 //cisnieine 171
						[17,20,24,28,32]
					],
					[ //wiek 68-+
						 //cisnieine 130
						[10,12,14,17,20], //cholesterol
						 //cisnieine 131-150
						[14,17,20,24,28],
						 //cisnieine 151-170
						[20,24,28,32,38],
						 //cisnieine 171
						[28,33,38,43,50]
					]
				],
				[ //papierosy - tak
					[ //wiek 0-45
						//cisnieine 130
						[1,1,2,2,3], //cholesterol
						//cisnieine 131-150
						[2,2,3,3,4],
						//cisnieine 151-170
						[3,3,4,4,5],
						//cisnieine 171
						[4,4,5,6,8]
					],
					[ //wiek 46-52
						//cisnieine 130
						[3,4,5,5,6], //cholesterol
						//cisnieine 131-150
						[5,5,6,8,9],
						//cisnieine 151-170
						[6,8,9,11,13],
						//cisnieine 171
						[9,11,13,16,18]
					],
					[ //wiek 53-57
						//cisnieine 130
						[5,6,7,8,10], //cholesterol
						//cisnieine 131-150
						[7,8,10,12,14],
						//cisnieine 151-170
						[10,12,14,17,20],
						//cisnieine 171
						[14,17,20,23,27]
					],
					[ //wiek 58-62
						//cisnieine 130
						[7,9,11,13,15], //cholesterol
						//cisnieine 131-150
						[11,13,15,18,21],
						//cisnieine 151-170
						[15,18,21,25,29],
						//cisnieine 171
						[21,25,29,34,39]
					],
					[ //wiek 63-67
						//cisnieine 130
						[12,14,17,20,23], //cholesterol
						//cisnieine 131-150
						[17,20,23,27,32],
						//cisnieine 151-170
						[23,27,32,37,43],
						//cisnieine 171
						[32,37,43,49,55]
					],
					[ //wiek 68-+
						//cisnieine 130
						[20,23,27,32,37], //cholesterol
						//cisnieine 131-150
						[27,32,37,43,49],
						//cisnieine 151-170
						[37,43,49,55,62],
						//cisnieine 171
						[49,56,62,69,76]
					]
				]
			],
			'f' : [
				[//papierosy - nie
					[ //wiek 0-45
						//cisnieine 130
						[0,0,0,0,0], //cholesterol
						//cisnieine 131-150
						[0,0,0,1,1],
						//cisnieine 151-170
						[0,1,1,1,1],
						//cisnieine 171
						[1,1,1,1,1]
					],
					[ //wiek 46-52
						//cisnieine 130
						[1,1,1,1,1], //cholesterol
						//cisnieine 131-150
						[1,1,1,1,2],
						//cisnieine 151-170
						[1,1,2,2,2],
						//cisnieine 171
						[2,2,2,3,3]
					],
					[ //wiek 53-57
						//cisnieine 130
						[1,1,1,1,2], //cholesterol
						//cisnieine 131-150
						[1,1,2,2,3],
						//cisnieine 151-170
						[2,2,3,3,4],
						//cisnieine 171
						[3,3,4,4,5]
					],
					[ //wiek 58-62
						//cisnieine 130
						[2,2,2,3,3], //cholesterol
						//cisnieine 131-150
						[2,3,3,4,5],
						//cisnieine 151-170
						[3,4,5,5,7],
						//cisnieine 171
						[5,6,7,8,9]
					],
					[ //wiek 63-67
						//cisnieine 130
						[3,3,4,5,6], //cholesterol
						//cisnieine 131-150
						[4,5,6,7,9],
						//cisnieine 151-170
						[6,7,9,10,12],
						//cisnieine 171
						[9,10,12,15,17]
					],
					[ //wiek 68-+
						//cisnieine 130
						[6,7,8,10,12], //cholesterol
						//cisnieine 131-150
						[8,10,12,14,17],
						//cisnieine 151-170
						[12,14,17,20,24],
						//cisnieine 171
						[17,20,24,28,32]
					]
				],
				[//papierosy - tak
					[ //wiek 0-45
						//cisnieine 130
						[0,1,1,1,1], //cholesterol
						//cisnieine 131-150
						[1,1,1,1,1],
						//cisnieine 151-170
						[1,1,1,2,2],
						//cisnieine 171
						[1,2,2,2,3]
					],
					[ //wiek 46-52
						//cisnieine 130
						[1,1,2,2,2], //cholesterol
						//cisnieine 131-150
						[2,2,2,3,3],
						//cisnieine 151-170
						[2,3,3,4,5],
						//cisnieine 171
						[3,4,5,5,7]
					],
					[ //wiek 53-57
						//cisnieine 130
						[2,2,3,3,4], //cholesterol
						//cisnieine 131-150
						[3,3,4,4,5],
						//cisnieine 151-170
						[4,4,5,6,7],
						//cisnieine 171
						[5,6,8,9,11]
					],
					[ //wiek 58-62
						//cisnieine 130
						[3,4,4,5,6], //cholesterol
						//cisnieine 131-150
						[5,5,6,8,9],
						//cisnieine 151-170
						[6,8,9,11,13],
						//cisnieine 171
						[9,11,13,15,18]
					],
					[ //wiek 63-67
						//cisnieine 130
						[6,7,8,10,12], //cholesterol
						//cisnieine 131-150
						[8,10,12,14,17],
						//cisnieine 151-170
						[12,14,17,20,23],
						//cisnieine 171
						[17,20,24,28,32]
					],
					[ //wiek 68-+
						//cisnieine 130
						[12,14,17,20,23], //cholesterol
						//cisnieine 131-150
						[17,20,23,27,32],
						//cisnieine 151-170
						[23,27,32,37,42],
						//cisnieine 171
						[32,37,43,49,55]
					]
				]
			]
		}
	},
	inicjalizacja : function() {
		var ob = this;
		var check = 0;
		for(i=1;i<9;i++) {
			var $inputChecked = $('#step'+i+' input:checked');
			var wynik = 0;
			$inputChecked.each(function(){
				$this = $(this);
				var name = $this.parents('#step'+i).data('input');
				var val = $this.val();
				if(name=='plec') 
					wynik = val;
				else
					wynik += parseInt(val);
				ob.inputs[name] = wynik;
			});
			
			if($inputChecked.length>0) {
				++check;
			} 
		}

		if(check>7) 
			return true;
		else
			return false;
	},
	WybierzPrzedzial : function(array,f,c,a) {
		var n = array[f][c].length;
		if(n>2) {
			if(array[f][c][0][0]>= a)
				return array[f][c][0][1];
			else if (array[f][c][n-1][0] <= a)
				return array[f][c][n-1][1];
			else {
				for(i=1;i<n-1;i++){
					if(array[f][c][i][0] >= a && array[f][c][i-1][0]<a)
						return array[f][c][i][1];
				};
			}
		} else {
			return array[f][c][a];
		}
		return 0;
	},
	WiekSerca: function() {
		var ob = this;
		var TempPlec = ob.inputs['plec'];
		var TempArray = ob.inputs;
		var punkty = 0;
		
		$.each(TempArray, function(key,val) {
			if(key != 'leki' && key != 'plec') {
				if(key == 'cisnienie' && TempArray['leki'] == 1)
					key = 'cisnienieLeki';
				punkty += ob.WybierzPrzedzial(ob.PointsAge,TempPlec,key,val);
			}
		});
		
		ob.wiek = ob.WybierzPrzedzial(ob.PointsAge,TempPlec,'wiekSerca',punkty);
		return ob.wiek;
	},
	RyzykoChoroby : function() {
		var ob = this;
		var TempWiek = ob.WybierzPrzedzial(ob.RiskPercent,'index','wiek',ob.inputs['wiek']);
		var TempCholesterol = ob.WybierzPrzedzial(ob.RiskPercent,'index','cholesterol',ob.inputs['cholesterol']);
		var TempCisnienie = ob.WybierzPrzedzial(ob.RiskPercent,'index','cisnienie',ob.inputs['cisnienie']);
		
		var ryzyko = ob.RiskPercent['procent'][ob.inputs['plec']][ob.inputs['papierosy']][TempWiek][TempCisnienie][TempCholesterol]
		return ryzyko;
	}
}

//
//CallBack dla CSSowych animacji
//
	function AnimateCallBack(el,callback,timeout) {
		var AnimationLag, TimeOutStart = false; 
					if(!TimeOutStart) {
				TimeOutStart = true;
				AnimationLag = setTimeout(function(){
									TimeOutStart = false;
									callback(el);
								}, timeout);
			}
		el.on('transitionend webkitTransitionEnd', function(e){
		e.stopPropagation();

			if(e.target == el.context || e.target == el[0]) {
				clearTimeout(AnimationLag);
				callback(el);
				el.off();
			}
		 $('*', el).on('transitionEnd webkitTransitionEnd', function(ev){ev.stopPropagation(); });
		});
	}
	
//
//Funkcja odpowiedzialna za przejście do następnego ekranu
//	
	function nextSlide(e) {
		if(e.target.classList[0] == 'button' || e.target.classList[0] == 'icon')
			$('label', $(this)).trigger('click');
		var $slide = $(this).parents('.slide');
		if(!$slide.is(':last-child') && !animate) {
			animate = true;
			if($slide.attr('id')=='step8') {				
				if(_BadanieWiekuSerca.inicjalizacja()) {
					var tempWiek = _BadanieWiekuSerca.WiekSerca();
				
					if($.isNumeric(tempWiek)) {
						var last = tempWiek.toString();
						var last = last[last.length-1];
						
						if(last == '2' || last == '3' || last == '4')
							last = "lata";
						else
							last = "lat";
						
						$('#wiekSerca').next().text(last);
					}
					
					$('#wiekSerca').html(tempWiek);
					$('#ryzykoChoroby').html(_BadanieWiekuSerca.RyzykoChoroby());
				} 
				
			}
			
			var $newSlide = $slide.next();
			$slide.removeClass('animate');
			$newSlide.addClass('active');
			
			SetStatus($slide.attr('id'),true);
			
			if($('.circle', $slide).length>0) {
				$('.slide-container', $slide).removeClass('ac');
				$('.circle', $slide).removeClass('active');
			}
			
			AnimateCallBack($('.sliderAnimation',$slide), function(el) {	
				$slide.removeClass('active');
				$newSlide.addClass('animate');
				AnimateCallBack($('.sliderAnimation',$newSlide), function(el) {	
					animate = false;
				},550);
			},550);
		}
	}
	
//
//Funkcja odpowiedzialna za przejście do poprzedniego ekranu
//
	function prevSlide(e) {
		var $slide = $(this).parents('.slide');
		if(!$slide.is(':first-child') && !animate) {
			animate = true;
		
			var $newSlide = $slide.prev();
			$slide.removeClass('animate');
			$newSlide.addClass('active');
			
			SetStatus($newSlide.attr('id'),false);
			
			if($('.circle', $slide).length>0) {
				$('.slide-container', $slide).removeClass('ac');
				$('.circle', $slide).removeClass('active');
			}
			
			if($newSlide.attr('id') == 'step4')
				$('.next p', $newSlide).text('pomiń');
			
			AnimateCallBack($('.sliderAnimation',$slide), function(el) {
				$('.next', $newSlide).css('display', 'none');
				$slide.removeClass('active');
				$newSlide.addClass('animate');
				
				SetStatus($slide.attr('id'),false);
				
				AnimateCallBack($('.sliderAnimation',$newSlide), function(el) {
					animate = false;
				},550);
			},550);
		}
	}

//
//Funkcja odpowiedzialna za pokazanie "tulipana"
//
	function showLittleCircle () {
		if(!animate) {
			var $this = $(this);
			var $parent = $this.parent()
			var $container = $parent.parent()
			var $littleCircle = $this.next();
			
			if(!$container.hasClass('ac')) {
				animate = true;
				
				$container.addClass('ac');
				$('.circle', $container).removeClass('active');
				$parent.addClass('active');
				
				setTimeout(function(){$littleCircle.addClass('show');},10);
	
				AnimateCallBack($('.animation_check',$parent), function(el) {
					animate = false;
				},350);
			}
		}
	}

//
//Funkcja odpowiedzialna za zmianę głównej cyfry (po wyborze z tulipana)
//
	function ChangeNumber() {
		if(!animate) {
			$('label', $(this)).trigger('click');
			//animate = true;
			$this = $(this);
			var $LittleCircle = $this.parent();
			var nr = $('.value', $this).text();
			var $MainCircle = $LittleCircle.prev();
			var $Circle = $MainCircle.parent();
			var $container = $Circle.parent();
			var $slide = $container.parent();
			
			$('.lc', $LittleCircle).removeClass('active');
			$this.addClass('active');
			$MainCircle.children().text(nr);

			$LittleCircle.removeClass('show');
			
			//AnimateCallBack($('.animation_check',$LittleCircle), function(el) {
			//	animate = false; 
				$container.removeClass('ac');
				$Circle.removeClass('active');
			//},350);

			if(InuptValue($slide)>0) {
				if($slide.attr('id') != 'step4') 
					$('.next', $slide).removeClass('transition').fadeIn(250,function(){
						$(this).addClass('transition');
					});
				else
					$('.next p', $slide).text('dalej');
			} else {						
				if($slide.attr('id') != 'step4') 
					$('.next', $slide).removeClass('transition').fadeOut(250,function(){
						$(this).addClass('transition');
					});
				else
					$('.next p', $slide).text('pomiń');
			}
			 
		}
	}
	
//
//Funkcja odpowiedzialna za odczytanie pełnej wartości z inputów
//
	function InuptValue(step) {
		var $inputChecked = $('input:checked',step);
		var wynik = 0;
		$inputChecked.each(function(){
			$this = $(this);
			var val = $this.val();
			wynik += parseInt(val);
		});
		return wynik;
	}
	
//
//Funkcja odpowiedzialna za wpisanie wybranej zawartości
//
	function SetStatus(step,del) {
		var text = '';
		var $statusBox = $('.statistics .'+step);
		
		if(del) {
			if(step == 'step1')
				text = $('#'+step+' input:checked').val() == 'm' ? 'mężczyzna' : 'kobieta';
			else if(step == 'step2')	{
				text = InuptValue($('#'+step));
				var n1 = parseInt($('#'+step+' .c1 input:checked').val());
				var n2 = parseInt($('#'+step+' .c10 input:checked').val());
				var n3 = parseInt($('#'+step+' .c100 input:checked').val());
				
				if(n1 == 1 && n2 == 0 && n3 ==0) {
					$('.sl', $statusBox).text('rok');
				} else if(n1 == 2 || n1 == 3 || n1 == 4) {
					$('.sl', $statusBox).text('lata');
				} else {
					$('.sl', $statusBox).text('lat');
				}
			} else if(step=='step4') {
				text = InuptValue($('#'+step));
				text = text > 0 ? text : 'pominięte';
			} else if(step=='step3' || step=='step5')
				text = InuptValue($('#'+step));
			else
				text = $('#'+step+' input:checked').val() == '0' ? 'NIE' : 'TAK';
			
			$statusBox.addClass('show');
			$('span:first-child', $statusBox).text(text);
		} else {
			if(step == 'step2' || step=='step3' || step=='step4' || step=='step5'){
				$('#'+step+' input').attr('checked',false);
				$('#'+step+' .lc').removeClass('active');
				
				$('#'+step+' input[value=0]').each(function() {
					$(this).attr('checked',true);
					$(this).trigger('click');
					var $lc = $(this).parents('.lc');
					var $littleCircle = $lc.parents('.little_circle');
					var $mainCircle = $littleCircle.prev();
					
					$lc.addClass('active');
					$('.value', $mainCircle).text('0');
				});
			} else
				$('#'+step+' input:checked').attr('checked',false);
			
			$statusBox.removeClass('show');
		}
	}
	
		
//
//Funkcja zresetowanie aplikacji
//
	function RESET() {
		if(!animate) {
			animate = true;
			$('.statistics .stats').removeClass('show');
			
			var $slide = $(this).parents('.slide');
			var $newSlide = $('#intro');
			$slide.removeClass('animate');
			$newSlide.addClass('active');
			
			SetStatus($slide.attr('id'),true);
			
			AnimateCallBack($('.sliderAnimation',$slide), function(el) {	
				$slide.removeClass('active');
				$newSlide.addClass('animate');
				
				$('#step4 .next p').text('pomiń');
				$('.slide-container').removeClass('ac');
				$('.circle').removeClass('active');
				$('.slide').not('#intro').children('.next').css('display', 'none');
				
				$('input:checked').attr('checked',false);
				$('.lc').removeClass('active');
				
				$('input[value=0]').each(function() {
					$(this).attr('checked',true);					
					$(this).trigger('click');
					var $lc = $(this).parents('.lc');
					var $littleCircle = $lc.parents('.little_circle');
					var $mainCircle = $littleCircle.prev();
					
					$lc.addClass('active');
					$('.value', $mainCircle).text('0');
				});
					
				animate = false;
			},550);
		}
	}
	
$(document).ready(function(){ 
 	$(document).on('click', '.prev', prevSlide);
	$(document).on('click', '.next', nextSlide);
	$(document).on('click', '.exit', RESET);
	$(document).on('click', '#step1 .buttons .icon', nextSlide);
	$(document).on('click', '.buttons .button', nextSlide);
	$(document).on('click', '.buttons label', function(e) {
		e.stopPropagation();
	});
	
	$(document).on('click', '.main_circle', showLittleCircle);
	$(document).on('click', '.little_circle .lc', ChangeNumber);
	$(document).on('click', '.little_circle .lc label', function(e) {
		e.stopPropagation();
	});	
});